#include "intType.hh"
#include "Variable.hh"

namespace EUROPA {
  
  //
  // intTypeFactory
  //

  intTypeFactory::intTypeFactory()
    : IntervalIntTypeFactory(getDefaultTypeName().c_str(), getDefaultTypeName().c_str()){}

  double intTypeFactory::createValue(const std::string& value) const
  {
    if (value == "-inf") {
      return MINUS_INFINITY;
    }
    if (value == "+inf") {
      return PLUS_INFINITY;
    }
    return atoi(value.c_str());
  }

  const LabelStr& intTypeFactory::getDefaultTypeName() {
    static const LabelStr sl_typeName("int");
    return(sl_typeName);
  }

} // namespace EUROPA
